/*
COPYRIGHT STATEMENT

NOTE: This copyright statement applies to all individual files or
modules in which the developers listed below are mentioned.

This software module was originally developed by the Lucent Technologies
Murray Hill, New Jersey, USA. Contributors to the software
include but are not limited to: Eric Petajan and Jialin Zhong.
This software module is an implementation of a part of one or more
MPEG-4 Visual (ISO/IEC 14496-2) tools as specified by MPEG-4 Visual
(ISO/IEC 14496-2). ISO/IEC gives users of the MPEG-4 Visual standard
free license to this software module or modifications thereof for
use in hardware or software products claiming conformance to the
MPEG-4 Visual (ISO/IEC 14496-2) standard. Those intending to use
this software module in hardware or software products are advised
that its use may infringe existing patents. The original developers
of this software and his/her company, the subsequent editors and
their companies, and ISO/IEC have no liability for use of this
software module or modifications thereof. Copyright is not released
for non MPEG-4 Visual standard conforming products. The original
developers retain full right to use the code for its own purpose,
assign or donate the code for non MPEG-4 Visual conforming products.
This copyright notice must be included in all copies or derivative
works.

Copyright (c) 1997

CONTRIBUTION TO THE WG11 PROGRAM MPEG 4 PLAYER
______________________________________________________________________

STANDARDS PROJECT:  MPEG 4 Player
______________________________________________________________________

TITLE:  3D Line-Based Face Animation Module
______________________________________________________________________

AUTHORS:  Eric Petajan, Jialin Zhong

SOURCE:      Lucent Technologies Inc.

CONTACT:        Eric Petajan
                Lucent Technologies
                Room 2B231
                600 Mt. Ave.
                Murray Hill, NJ  07974
                Voice:  +1 908-582-3160
                Fax: +1 908-582-6632
                Email:  edp@bell-labs.com
______________________________________________________________________


ABSTRACT:  this module inputs face animation and definition parameters,
and outputs 3D points, lines, and polygons.
*/

#include "wireface.h"

struct LightSource *light;
	
extern Display	*dpy;
extern GLXContext	cx;

extern GLboolean doubleBuffer; 

/*OpenGL initializations*/
float light_position[]={
	-0.497468, 0.497468, .710669, 0.0
}, light_ambient[]={
	0.3, 0.3, 0.3,0.0
}, light_diffuse[]={
	1.0, 1.0, 1.0,0.0
};

float lightmodel_ambient[]={
	0.2, 0.2, 0.2,0.0
};

extern GLint Image_Width, Image_Height;

void plot_init(Widget w) {
int i;

   glInitNames();
   glClear(GL_DEPTH_BUFFER_BIT);
   glClearDepth(-6000.0);
   glClearColor(0.0, 0.0, 0.0, 0.0);
   glClear(GL_COLOR_BUFFER_BIT);
   glViewport(-50.0, -50.0, Image_Width-1, Image_Height-1);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   glOrtho(-50.0,50.0,-50.0, 50.0, 6000.0, -6000.0);
   /*initialize the light source*/
   glLightfv(GL_LIGHT0, GL_POSITION, light_position);
   glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient);
   glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
   /*initialize the light model*/
   glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_FALSE);
   glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lightmodel_ambient);
   gluLookAt(0.0,0.0, 400.0,0.0, 0.0,0.0,0.0,10.0,0.0);
   /*
   glEnable(GL_LIGHTING);
   glEnable(GL_LIGHT0);
   */
   glEnable(GL_DEPTH_TEST);
   glDepthFunc(GL_GEQUAL);

}
