
#include <sys/types.h> /* for unix open() */
#include <sys/stat.h>  /* for unix open() */
#include <fcntl.h>     /* for unix open() */
#include <sys/prctl.h>
#include <dmedia/audio.h>     /* audio library header */
#include <signal.h>    /* for signal handler */
#include <math.h>
int caught_sigint =  0;     /* completion flag */


static int rec_cmd = 0;   /* 0 = wait, 1 = rec, 2 = quit */
static int play_cmd = 0;   /* 0 = wait, 1 = rec, 2 = quit */

short *buf;/*[48000 * 2 * NSECONDS]*/
long nsamps;/* = 48000 * 2 * NSECONDS;for stereo  */
/*long nsamps = 48000 *NSECONDS;for mono*/
/*extern short buf[48000 * 2 * NSECONDS];*/
/*extern long nsamps;*/

void record_audio_proc(int n);
void play_audio_proc(int n);

init_audio(float nseconds,char *audiofilename)
{ int i;
int fd;

  int rec_proc, play_proc;
  nsamps = (int)ftrunc(nseconds*48000.0*2.0);/*for stereo*/
  if(buf = (short *)malloc(nsamps*sizeof(short)));
  else printf("out of memory for audio samples\n");
  fd = open(audiofilename,O_RDONLY);
  /*  read(fd,buf,502819);*/
  /*read(fd,buf,1005638);10 second mono*/
  read(fd,buf,nsamps*2);
 /*  sproc processes */

  /* rec_proc = sproc( (void *) record_audio_proc,PR_SALL,0); */
 play_proc = sproc((void *) play_audio_proc,PR_SALL,0); 

 

#if 0
 while(i!=0)
 {
  printf("1=record   2=play   0=quit\n");
  scanf("%d",&i);
  switch(i)
   { case 0:  rec_cmd = 2; play_cmd = 2; break;
     case 1:  rec_cmd = 1; break;
     case 2:  play_cmd = 1; break;
   }
 }
#endif

}

record_audio()
{
 rec_cmd = 1;
}

play_audio()
{
 play_cmd = 1;
}


void record_audio_proc(int n)
{
   ALconfig config;              /* port configuration structure  */
   ALport inport;                /* audio port structure          */
   int quit = 0;
   int num;
   int fd;

   printf("record_proc started\n");
   prctl(PR_TERMCHILD);        /*  Exit when parent does */
   sigset(SIGHUP, SIG_DFL);    /*  Exit when sent SIGHUP by TERMCHILD */

   config = ALnewconfig();
   ALsetqueuesize(config, 48000);
   ALsetwidth(config, AL_SAMPLE_16);   /* 16-bit signed samples    */
   ALsetchannels(config, AL_STEREO);
   /*ALsetchannels(config, AL_MONO);*/
   inport = ALopenport("inport", "r", config);

   while(!quit)
   { 
	switch(rec_cmd)
	{ case 0:
		break;
	  case 1:
printf("rec num = \n");
		num = ALgetfilled(inport);
		ALreadsamps(inport, buf, num);
		ALreadsamps(inport, buf, nsamps);
		rec_cmd = 0;	
printf("rec done\n");
		fd = open("recordfile", O_CREAT| O_WRONLY | O_TRUNC);/*edp*/
		write(fd, buf, nsamps*sizeof(short));
		close(fd);
		break;

	  case 2:
		quit = 1;
		break;
	}
     
   }

   ALfreeconfig(config);               /* free the config object    */
   ALcloseport(inport);                /* shut down the input port  */
   printf("record audio proc shutting down.\n");
   return;
}



void play_audio_proc(int n)
{
   ALconfig config;              /* port configuration structure  */
   ALport outport;                /* audio port structure          */
   int quit = 0;

   printf("play audio proc started\n");

    prctl(PR_TERMCHILD);        /*  Exit when parent does */
    sigset(SIGHUP, SIG_DFL);    /*  Exit when sent SIGHUP by TERMCHILD */

   config = ALnewconfig();
   ALsetqueuesize(config, 48000*2);
   ALsetwidth(config, AL_SAMPLE_16);   /* 16-bit signed samples    */
   ALsetchannels(config, AL_STEREO);
   /*ALsetchannels(config, AL_MONO);*/
   outport = ALopenport("outport", "w", config);

   while(!quit)
   {
        switch(play_cmd)
        { case 0:
                break;
          case 1:
                ALwritesamps(outport, buf, nsamps);
                play_cmd = 0;
                break;

          case 2:
                quit = 1;
                break;
        }

   }

   ALfreeconfig(config);               /* free the config object    */
   ALcloseport(outport);                /* shut down the output port  */
   printf("record audio proc shutting down.\n");
   return;
}

