/*
COPYRIGHT STATEMENT

NOTE: This copyright statement applies to all individual files or
modules in which the developers listed below are mentioned.

This software module was originally developed by the Lucent Technologies
Murray Hill, New Jersey, USA. Contributors to the software
include but are not limited to: Eric Petajan and Jialin Zhong.
This software module is an implementation of a part of one or more
MPEG-4 Visual (ISO/IEC 14496-2) tools as specified by MPEG-4 Visual
(ISO/IEC 14496-2). ISO/IEC gives users of the MPEG-4 Visual standard
free license to this software module or modifications thereof for
use in hardware or software products claiming conformance to the
MPEG-4 Visual (ISO/IEC 14496-2) standard. Those intending to use
this software module in hardware or software products are advised
that its use may infringe existing patents. The original developers
of this software and his/her company, the subsequent editors and
their companies, and ISO/IEC have no liability for use of this
software module or modifications thereof. Copyright is not released
for non MPEG-4 Visual standard conforming products. The original
developers retain full right to use the code for its own purpose,
assign or donate the code for non MPEG-4 Visual conforming products.
This copyright notice must be included in all copies or derivative
works.

Copyright (c) 1997

CONTRIBUTION TO THE WG11 PROGRAM MPEG 4 PLAYER
______________________________________________________________________

STANDARDS PROJECT:  MPEG 4 Player
______________________________________________________________________

TITLE:  3D Line-Based Face Animation Module
______________________________________________________________________

AUTHORS:  Eric Petajan, Jialin Zhong

SOURCE:      Lucent Technologies Inc.

CONTACT:        Eric Petajan
                Lucent Technologies
                Room 2B231
                600 Mt. Ave.
                Murray Hill, NJ  07974
                Voice:  +1 908-582-3160
                Fax: +1 908-582-6632
                Email:  edp@bell-labs.com
______________________________________________________________________


ABSTRACT:  this module inputs face animation and definition parameters,
and outputs 3D points, lines, and polygons.
*/


#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <string.h>
#include <sys/stat.h>
#include <unistd.h>
#include <math.h>

#include <Xm/MainW.h>
#include <Xm/RowColumn.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/CascadeB.h>
#include <Xm/FileSB.h>
#include <Xm/SelectioB.h>
#include <Xm/Frame.h>
#include <Xm/Form.h>
#include <Xm/MessageB.h>
#include <Xm/ToggleB.h>
#include <Xm/ToggleBG.h>
#include <Xm/DrawingA.h>        /* Motif drawing area widget */
#include <Xm/BulletinB.h>
#include <Xm/Scale.h>
#include <Xm/SelectioB.h>
#include <Xm/List.h>
#include <Xm/Label.h>
#include <Xm/RowColumn.h>
#include <Xm/PanedW.h>
#include <GL/GLwMDrawA.h> /* IRIX 5.2: Motif OpenGL drawing area widget */
#include <X11/keysym.h>
#include <X11/Shell.h>

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glx.h>

#define IMAGE_WIDTH 640
#define IMAGE_HEIGHT 480
#define QUIT            -1
#define TEST            -2
#define GUI             -3
#define GET             -4
#define RULE            -5
#define STRENGTH        -6
#define TIME            -7
#define THETA           -8
#define THETF           -9
#define TRACK           -10
#define MATTER          -11
#define LIGHTING        -12
#define TEXTURE         -13
#define EYELIGHT        -14
#define PINTERP         -15
#define EYETEX          -16
#define SAYTRAN         -17
#define NILL            100     /* ERROR!!! */

struct LightSource {
   float *position;
   float *ambient;
   float *diffuse;
   float *specular;
};

struct LightModel {
   float *ambient;
};

typedef struct _Material {
   char *name;
   float ambient[4];
   float diffuse[4];
   float specular[4];
   float emission[4];
   float shininess[1];
} Material;

#define IRISLINES 4
#define SHOWTEETH 1
#define SHOWTONGUE 1
void map_state_changed();
void plot();
void plot_init();
void resize();

typedef struct {
  int **isfeatpnt;/*[16][20] set if featpnt read from fdp file*/
  float ***featpts;/*[16][20][5] group.num.dimension (including u,v)*/
  float MWFAPUperpel,MNSFAPUperpel,ENSFAPUperpel,ESFAPUperpel,IRISDFAPUperpel;
  float dispscale;
  float version;
} FDPtype;

typedef struct {
  int **fapmask;/*[MAXFRAMES][69] framenumber,fapnum, note: fapmask[n][0] is not used*/
  int **faps;/*[MAXFRAMES][69] 0th is framenum, not a fap*/
  float **lfaps;/*[MAXFRAMES][69] faps in local face scale*/
  int framecount,framerate;
  char *basename;/*[256]*/
  float version;
} FAPtype;

extern void init_audio(float,char*);
